diff -urN xorg-server-1.3.0.orig/hw/xfree86/dri/sarea.h xorg-server-1.1.1/hw/xfree86/dri/sarea.h
--- xorg-server-1.3.0.orig/hw/xfree86/dri/sarea.h	2006-07-06 02:31:40.000000000 +0800
+++ xorg-server-1.3.0/hw/xfree86/dri/sarea.h	2007-10-30 14:23:47.000000000 +0800
@@ -44,6 +44,8 @@
 /* SAREA area needs to be at least a page */
 #if defined(__alpha__)
 #define SAREA_MAX 			0x2000
+#elif defined(__mips__)
+#define SAREA_MAX			0x4000
 #elif defined(__ia64__)
 #define SAREA_MAX			0x10000		/* 64kB */
 #else
--- xorg-server-1.3.0/hw/xfree86/os-support/linux/lnx_video.c.orig	2008-06-07 11:41:04.000000000 +0800
+++ xorg-server-1.3.0/hw/xfree86/os-support/linux/lnx_video.c	2008-06-07 11:44:54.000000000 +0800
@@ -540,9 +540,10 @@
 _X_EXPORT Bool
 xf86EnableIO(void)
 {
-#if defined(__powerpc__)
+#if defined(__powerpc__) || defined(__mips__)
 	int fd;
 	unsigned int ioBase_phys;
+        extern unsigned int IOPortBase;
 #endif
 
 	if (ExtendedEnabled)
@@ -567,6 +568,21 @@
 #endif
 	}
 	close(fd);
+#elif defined(__mips__)
+       fd = open("/dev/mem", O_RDWR);
+       IOPortBase = (volatile unsigned char *)mmap(0, 0x20000,
+                       PROT_READ | PROT_WRITE, MAP_SHARED, fd,
+                       0x1fd00000);
+       if (IOPortBase == MAP_FAILED) {
+               xf86Msg(X_WARNING,
+                               "xf86EnableIOPorts: Failed to map iobase (%s)\n",
+                               strerror(errno));
+               return FALSE;
+       }
+       close(fd);
+       xf86Msg(X_WARNING,
+              "xf86EnableIOPorts: map iobase (%x)\n",
+               IOPortBase);
 #elif !defined(__mc68000__) && !defined(__sparc__) && !defined(__mips__) && !defined(__sh__) && !defined(__hppa__) && !defined(__s390__) && !defined(__arm__)
         if (ioperm(0, 1024, 1) || iopl(3)) {
                 if (errno == ENODEV)
